#include<iostream>

using namespace std;

int N, K;
int poz_niz[1000000], neg_niz[1000000];
int rez, rez_niz[1000000];
int i, a;

int main(){
	ios_base::sync_with_stdio(false);
	cin.tie(nullptr);
	cout.tie(nullptr);
	cerr.tie(nullptr);
	
	cin >> N >> K;
	for (i = 0; i < N; i++){
		cin >> a;
		if (a >=0){
			poz_niz[a]++;
			if (poz_niz[a] == K) rez_niz[rez] = a, rez++;
		}
		else {
			a *= -1;
			neg_niz[a]++;
			if (neg_niz[a] == K) rez_niz[rez] = -1*a, rez++;
		}
	}
	cout << rez << '\n'; rez = rez-1;
	for(i = 0; i < rez; i++) cout << rez_niz[i] << ' ';
	cout << rez_niz[i];
	return 0;
}